
package de.ivu.elect.business.entschaedigung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.entschaedigung.entity.Entschaedigungsart;

@RequestScoped
@Named(EntschaedigungsartConversationSelect.COMPONENT_NAME)
public class EntschaedigungsartConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "entschaedigungsartConversationSelect";

  @Inject
  protected transient EntschaedigungsartExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(EntschaedigungsartConversationStore.class)
  protected transient EntschaedigungsartConversationStore conversationStore;

  public EntschaedigungsartConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Entschaedigungsart getEntity() {
    return getEntityInternal();
  }

  private Entschaedigungsart getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Entschaedigungsart entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Entschaedigungsart entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Entschaedigungsart attach(Entschaedigungsart entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Entschaedigungsart attach( de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
